-- Advanced Trailer Steering script

-- 27/06/2013

-- Script by Druptown (FMC)



steeringMod = {};

function steeringMod:load(xmlFile)
self.setAdvancedSteering = steeringMod.setAdvancedSteering;
	self.steeringAxleUpdateBackwards = true;
	
	self.activateAdvancedSteering = false;

	for _,wheel in pairs(self.wheels) do
		if wheel.steeringAxleScale ~= 0 then
			self.activateAdvancedSteering = true;
			break;
		end;
	end;
end;
Attachable.load = Utils.appendedFunction(Attachable.load, steeringMod.load);
	
function steeringMod:readStream(streamId, connection)
	if self.activateAdvancedSteering then
		self:setAdvancedSteering(streamReadBool(streamId), true)
	end;
end;
Attachable.readStream = Utils.appendedFunction(Attachable.readStream, steeringMod.readStream);

function steeringMod:writeStream(streamId, connection)
	if self.activateAdvancedSteering then
		streamWriteBool(streamId, self.steeringAxleUpdateBackwards);
	end;
end;
Attachable.writeStream = Utils.appendedFunction(Attachable.writeStream, steeringMod.writeStream);

function steeringMod:update(dt)	
	if self.activateAdvancedSteering then
		if self:getIsActiveForInput() then
			if InputBinding.hasEvent(InputBinding.DISABLE_STEERING) then
				self:setAdvancedSteering(not self.steeringAxleUpdateBackwards);
			end;
		end;
	end;
end;
Attachable.update = Utils.appendedFunction(Attachable.update, steeringMod.update);

function steeringMod:draw()
	if self:getIsActiveForInput() then
		if self.activateAdvancedSteering then
			if self.steeringAxleUpdateBackwards then
				g_currentMission:addHelpButtonText(g_i18n:getText("Disable Steering"), InputBinding.DISABLE_STEERING);
			else 
				g_currentMission:addHelpButtonText(g_i18n:getText("Enable Steering"), InputBinding.DISABLE_STEERING);
			end;
		end;
	end;
end;
Attachable.draw = Utils.appendedFunction(Attachable.draw, steeringMod.draw);

function steeringMod:setAdvancedSteering(bool, noEventSend)
	self.steeringAxleUpdateBackwards = bool;
	
	setAdvancedSteeringEvent.sendEvent(self, bool, noEventSend);
end;


setAdvancedSteeringEvent = {};
setAdvancedSteeringEvent_mt = Class(setAdvancedSteeringEvent, Event);

InitEventClass(setAdvancedSteeringEvent, "setAdvancedSteeringEvent");

function setAdvancedSteeringEvent:emptyNew()
    local self = Event:new(setAdvancedSteeringEvent_mt);
    self.className = "setAdvancedSteeringEvent";
	
    return self;
end;

function setAdvancedSteeringEvent:new(object, bool)
    local self = setAdvancedSteeringEvent:emptyNew()
    self.object = object;
	self.bool = bool;
	
    return self;
end;

function setAdvancedSteeringEvent:readStream(streamId, connection)
    local object = streamReadInt32(streamId);
    local bool = streamReadBool(streamId);
	self.bool = bool;
    self.object = networkGetObject(object);
    self:run(connection);
end;

function setAdvancedSteeringEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteBool(streamId, self.bool);
end;

function setAdvancedSteeringEvent:run(connection)
	self.object:setAdvancedSteering(self.bool, true);
	
	if not connection:getIsServer() then
		g_server:broadcastEvent(setAdvancedSteeringEvent:new(self.object, self.bool), nil, connection, self.object);
	end;
end;

function setAdvancedSteeringEvent.sendEvent(object, bool, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(setAdvancedSteeringEvent:new(object, bool), nil, nil, object);
		else
			g_client:getServerConnection():sendEvent(setAdvancedSteeringEvent:new(object, bool));
		end;
	end;
end;